//
// Infinite Star Racer for Cybiko by ssjx (2015)
//

#include <cybiko.h>
#include "header.h"

// in utils.c
void snapshot(char *);
int waitinput(struct module_t *);
void center(struct module_t *,char *,int );

// here
void shot_add(int x,int y,int xdir,int ydir,int owner);
void stars_draw();
//
//
//
struct module_t main_module;
struct DirectKeyboard *keys;

struct Input * ptr_input;
struct Bitmap bmp_block,bmp_angle,bmp_vert,bmp_dest,bmp_ship,bmp_shot,bmp_eshot;

struct Graphics gfx_buf;
struct Bitmap bmp_buf;

click_kind_t click_type;

struct{
	int x;
	int y;
	int inv;
	int lives;
	int score;
}player;

struct{
	int t;
	int fire;
	int x;
	int y;
}debris[10];

struct{
	int a;	// 0=off, 1=player, 2=enemy
	int x;
	int y;
	int xdir;
	int ydir;
	
}shot[30];

struct{
	int x;
	int y;	
}star[20];

int objects=7;

//
// 
//


void draw(struct module_t *ptr_main_module)
{
	int c=0;
	int i,j;
	
	Graphics_fill_screen( &gfx_buf, CLR_WHITE );
	
	stars_draw();
	
	TGraph_set_draw_mode( main_module.m_gfx, DM_PUT );
	
	
	
	for (i=0;i<objects;i++)	
	{
		switch(debris[i].t)
			{
			
			case 1:
				// solid
				Graphics_draw_bitmap( &gfx_buf, &bmp_block, debris[i].x,debris[i].y, BM_NORMAL );		
			break;
		
			case 2:
				// destructable	
				Graphics_draw_bitmap( &gfx_buf, &bmp_dest, debris[i].x,debris[i].y, BM_NORMAL );
			break;
		
			case 3:
				// angle shot	
				Graphics_draw_bitmap( &gfx_buf, &bmp_angle, debris[i].x,debris[i].y, BM_NORMAL );
				
				if (debris[i].fire==0 && random(100)>80)
				{
					shot_add(debris[i].x+4,debris[i].y+4,2,2,2);
					shot_add(debris[i].x+4,debris[i].y+4,-2,2,2);
					shot_add(debris[i].x+4,debris[i].y+4,-2,-2,2);
					shot_add(debris[i].x+4,debris[i].y+4,2,-2,2);
					debris[i].fire=50;
				}
				
				if (debris[i].fire>0){debris[i].fire--;}
			break;
			
			case 4:
				// h/v shot
				Graphics_draw_bitmap( &gfx_buf, &bmp_vert, debris[i].x,debris[i].y, BM_NORMAL );
				
				if (debris[i].fire==0 && random(100)>80)
				{
					shot_add(debris[i].x+4,debris[i].y+4,2,0,2);
					shot_add(debris[i].x+4,debris[i].y+4,-2,0,2);
					shot_add(debris[i].x+4,debris[i].y+4,0,-2,2);
					shot_add(debris[i].x+4,debris[i].y+4,0,2,2);
					debris[i].fire=50;
				}	
				
				
				if (debris[i].fire>0){debris[i].fire--;}
				
			break;
		
		
		}
		
		if (debris[i].t>0)
		{
			debris[i].x--;
				
			if (debris[i].x<=-16)
			{
				debris[i].t=1+random(4);
				debris[i].x=160+4;
				debris[i].y=random(84);	//100-16
				debris[i].fire=30;
			}
		}
		
	}
	
  	TGraph_set_draw_mode( &gfx_buf, DM_OR );
	TGraph_set_bkcolor( &gfx_buf, CLR_WHITE );

	// Draw shots
	for(i=0;i<20;i++)
	{
		switch(shot[i].a)
		{
			case 1:
				Graphics_draw_bitmap(&gfx_buf, &bmp_shot, shot[i].x, shot[i].y, BM_NORMAL );
			break;
			
			case 2:
				Graphics_draw_bitmap(&gfx_buf, &bmp_eshot, shot[i].x, shot[i].y, BM_NORMAL );
			break;
		}
	}
	
	//draw player
	Graphics_draw_bitmap(&gfx_buf, &bmp_ship, player.x, player.y, BM_NORMAL );
}



//
//
//

void reset()
{
	int i=0;
	
	for(i=0;i<10;i++)
	{
		//debris[i].t=1;
		debris[i].t=1+random(4);
		debris[i].x=160+random(160);
		debris[i].y=random(84);	//100-16
		debris[i].fire=30;
	}

	for(i=0;i<20;i++)
	{
		shot[i].a=0;
	}

	player.x=80;
	player.y=50;
	player.inv=0;
	player.score=0;
	player.lives=3;
	
	objects=5;
}


//
//
//

void shot_add(int x,int y,int xdir,int ydir,int owner)
{
	int i;

	switch (owner)
	{
		case 1:
			for(i=0;i<10;i++)
			{
				if (shot[i].a==0)
				{
				shot[i].a=owner;
				shot[i].x=x;
				shot[i].y=y;
				
				shot[i].xdir=xdir;
				shot[i].ydir=ydir;
				
				
				break;
				}
			}
		break;
		
		case 2:
			for(i=10;i<30;i++)
			{
				if (shot[i].a==0)
				{
				shot[i].a=owner;
				shot[i].x=x;
				shot[i].y=y;
				
				shot[i].xdir=xdir;
				shot[i].ydir=ydir;
				break;
				}
			}
		break;
	}
	
}

// block is 8x8
int hit_rect(int sx,int sy,int rx, int ry)
{
	if (sx>=rx && sx<=rx+16)
	{
		if (sy>=ry && sy<=ry+16)
		{
		return 1;
		}
	}
	
	return 0;
}

// ship is 16x8
int hit_ship(int sx,int sy,int rx, int ry)
{
	if (sx>=rx && sx<=rx+16)
	{
		if (sy>=ry && sy<=ry+8)
		{
		return 1;
		}
	}
	
	return 0;
}

int shot_update()
{
	int c=0,i=0,j=0;

	for(i=0;i<20;i++)
	{
		switch(shot[i].a)
		{
		case 1:
			// player shot
			// shot hit anything?
			for(j=0;j<objects;j++)
			{
				if (hit_rect(shot[i].x+4,shot[i].y+8, debris[j].x,debris[j].y)==1)
				{
					//debris[j].t=0;
					if (debris[j].t==2)	
					{
						player.score+=5;
						
						debris[j].t=1+random(4);
						debris[j].x=160+4;
						debris[j].y=random(84);	//100-16
						debris[j].fire=50;
					}
					
					shot[i].a=0;
				}
			}
		break;
		
		case 2:
			//enemy shot
			if (hit_ship(shot[i].x+4,shot[i].y+4, player.x,player.y)==1)
			{
				return 1;
			}
			
		
		break;
		}
		
		// Move active shot
		if (shot[i].a>0)
		{
			shot[i].x+=shot[i].xdir;
			shot[i].y+=shot[i].ydir;
			
			if (shot[i].x<0 || shot[i].x>160){shot[i].a=0;}
			if (shot[i].y<0 || shot[i].y>100){shot[i].a=0;}
			
			// Everything moves left...
			shot[i].x--;
		}	
	}
	
	
	return 0;	
}

//
// Stars
//

void stars_reset()
{
	int i;
	
	for(i=0;i<20;i++)
	{
		star[i].x=random(160);
		star[i].y=random(100);
	}
}

void stars_draw()
{
	int i;

	for(i=0;i<20;i++)
	{
	TGraph_set_pixel(  &gfx_buf, star[i].x, star[i].y, CLR_DKGRAY );
	}
}

void stars_update()
{
	int i;
	
	for(i=0;i<20;i++)
	{
		star[i].x--;
		if (star[i].x<0)
		{
		star[i].x=160;
		star[i].y=random(100);
		}
	}
}

// Ship collide with debris?

int ship_collision()
{	
	int i;
	int sx,sy,dx,dy;
		
	sx=player.x;
	sy=player.y;
	
	for(i=0;i<objects;i++)
	{
		dx=debris[i].x;
		dy=debris[i].y;
		
		// TOP
		sy=player.y;
		
		// left
		if (sx>=dx && sx<=dx+16)
		{
			if (sy>=dy && sy<=dy+16)
			{
			return 1;
			}
		}
		
		// right
		if ((sx+16)>=dx && (sx+16)<=dx+16)
		{
			if (sy>=dy && sy<=dy+16)
			{
			return 2;
			}
		}
		
		// BOTTOM
		sy+=8; 
		// left
		if (sx>=dx && sx<=dx+16)
		{
			if (sy>=dy && sy<=dy+16)
			{
			return 1;
			}
		}
		
		// right
		if ((sx+16)>=dx && (sx+16)<=dx+16)
		{
			if (sy>=dy && sy<=dy+16)
			{
			return 2;
			}
		}	
	}
	
	return 0;
}

//
//
// 
     
long main(int argc, char *argv[],bool start)
{
int i,ext=0,level=0,width;
int alt=0,takeshot=0,firecount=0;
int ctr=0;

int hiscore=10;
char score_str[20],level_str[20];
char *dis; //,*map;


Bitmap_ctor_Ex2( &bmp_buf, 160,100, 2 );
Graphics_ctor_Ex( &gfx_buf, &bmp_buf );
  

//map=(char *)malloc(250); 

TRACE("Infinite Star Racer by ssjx");

init_module( &main_module );

dis=DisplayGraphics_get_page_ptr(main_module.m_gfx, 0);
keys = DirectKeyboard_get_instance();
  
//
// Load our graphics
//
	
	Bitmap_ctor(&bmp_ship);
	
	ptr_input = open_resource_Ex( "ship.pic" );
	if (!Bitmap_load( &bmp_ship, ptr_input ))
	{
	TRACE("Error loading ship");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_block);
	
	ptr_input = open_resource_Ex( "block.pic" );
	if (!Bitmap_load( &bmp_block, ptr_input ))
	{
	TRACE("Error loading block");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	
	Bitmap_ctor(&bmp_angle);
	
	ptr_input = open_resource_Ex( "angle.pic" );
	if (!Bitmap_load( &bmp_angle, ptr_input ))
	{
	TRACE("Error loading angle");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_dest);
	
	ptr_input = open_resource_Ex( "dest.pic" );
	if (!Bitmap_load( &bmp_dest, ptr_input ))
	{
	TRACE("Error loading destructable");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_vert);
	
	ptr_input = open_resource_Ex( "vert.pic" );
	if (!Bitmap_load( &bmp_vert, ptr_input ))
	{
	TRACE("Error loading h/vertical");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	
	Bitmap_ctor(&bmp_shot);
	
	ptr_input = open_resource_Ex( "shot.pic" );
	if (!Bitmap_load( &bmp_shot, ptr_input ))
	{
	TRACE("Error loading shot");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
		//
	
	Bitmap_ctor(&bmp_eshot);
	
	ptr_input = open_resource_Ex( "shot.pic" );
	if (!Bitmap_load( &bmp_eshot, ptr_input ))
	{
	TRACE("Error loading enemy shot");
	}
	Input_dtor( ptr_input, FREE_MEMORY );

//
// Turn off keyboard beeping...
//	

click_type = get_click_kind(); // So we can restore it when we exit

set_click_kind( CK_NO );
//
//

stars_reset();
				
//
// Title Screen
//
do
{

	//TGraph_set_color( main_module.m_gfx, CLR_BLACK );
	Graphics_set_color( &gfx_buf, CLR_BLACK );
	Graphics_set_font( &gfx_buf, mini_normal_font ); // Set mini font

	
	//	
	Graphics_fill_screen( main_module.m_gfx, CLR_WHITE );
	DisplayGraphics_set_color( main_module.m_gfx, CLR_BLACK );
	
	Graphics_set_font( main_module.m_gfx, mini_normal_font ); // Set mini font
		
	Graphics_draw_text( main_module.m_gfx, "Infinite Star Racer", 1, 1 );
	Graphics_draw_text( main_module.m_gfx, "by ssjx", 1, 10 );
	Graphics_draw_text( main_module.m_gfx, "High Score", 1, 25 );
	
	sprintf(score_str,"%d",hiscore);
	Graphics_draw_text( main_module.m_gfx, score_str, 1, 35 );
	
	Graphics_draw_text( main_module.m_gfx, "Previous Score", 1, 45 );
	
	sprintf(score_str,"%d",player.score);
	Graphics_draw_text( main_module.m_gfx, score_str, 1, 55 );
	
	Graphics_draw_text( main_module.m_gfx, "Space = Start", 1, 80 );
	
	//footer
	TGraph_draw_line( main_module.m_gfx, 0, 89, 160, 89 );
	
	Graphics_draw_text( main_module.m_gfx, "http://ssjx.co.uk", 1, 90 );
	Graphics_draw_text( main_module.m_gfx, "v0.1", 140, 90 );
	
	DisplayGraphics_show(main_module.m_gfx );

	ext=0;
	if (waitinput(&main_module)==KEY_ESC)
	{
		TRACE("Escape from the title screen...");
		ext=2;
	}
	
	
	if (ext==0)
	{
	
		reset();
		ctr=0;
		
		do
		{
			// Get Player Input
			
			DirectKeyboard_scan( keys );
		
			if ( DirectKeyboard_is_key_pressed( keys, KEY_X ) )
			{
				TRACE("X - Exit!");
				ext=1;
			}
		
			if ( DirectKeyboard_is_key_pressed( keys, KEY_UP ) || DirectKeyboard_is_key_pressed( keys, KEY_Q ) )
			{	
				if (player.y>0){player.y-=2;}	
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_DOWN ) || DirectKeyboard_is_key_pressed( keys, KEY_A) )
			{
				if ((player.y+8)<100){player.y+=2;}	
			}
		
			if ( DirectKeyboard_is_key_pressed( keys, KEY_LEFT ) || DirectKeyboard_is_key_pressed( keys, KEY_O ) )
			{
				if (player.x>0){player.x-=2;}
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_RIGHT ) || DirectKeyboard_is_key_pressed( keys, KEY_P) )
			{
				if ((player.x+16)<160){player.x+=2;}	
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_SPACE ) || DirectKeyboard_is_key_pressed( keys, KEY_ENTER ))
			{
				if (firecount==0)
				{
					shot_add(player.x,player.y,4,0,1);
					firecount=10;
				}
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_H )  )
			{
				takeshot=1;
			}
	
	
			//
			// DRAW THE LEVEL
			//
			
			draw(&main_module.m_gfx);
			
			ctr++;
			if (ctr==10)
			{
				player.score++;
				
				if (player.score>50){objects=6;}
				if (player.score>100){objects=7;}
				
				sprintf(score_str,"%d",player.score);
				ctr=0;
			}
			
			
			// Draw status
			Graphics_set_color( &gfx_buf, CLR_BLACK );
			width=Font_string_width( DisplayGraphics_get_font(&gfx_buf),score_str );
			Graphics_draw_text( &gfx_buf, score_str, 160-width, 0 );
			
			
			// Display eveything
    			DisplayGraphics_put_background( main_module.m_gfx, Graphics_get_buf_addr( &gfx_buf ));
			DisplayGraphics_show(main_module.m_gfx );
			
			if (shot_update()==1){ext=1;}
			
			
			
			// Player hit debris?
			if (ship_collision()>0){ext=1;}
			
			// take a snapshot after we have drawn everything
			if (takeshot==1)
			{
				snapshot(dis);
				takeshot=0;
			}
			
			//May need to slow it down for Cybiko Xtremes?
			//sleep(10);
		
			alt=1-alt;
			
			if (alt==1){stars_update();}
			
			if (firecount>0){firecount--;}
		
		//
		}while(ext==0);

		switch(ext)
		{
			case 1:
				//Player lost all lives...
				center(&main_module,"Gameover!",45);
				DisplayGraphics_show(main_module.m_gfx );
				waitinput(&main_module);
				
				if (player.score>hiscore){hiscore=player.score;}
			break;
		}
	}

}while(ext!=2);

//	center(&main_module,"Thanks for playing!",45);
//	DisplayGraphics_show(main_module.m_gfx );
//	waitinput(&main_module);

TRACE("Finished");

set_click_kind( click_type );

DirectKeyboard_dtor( keys, FREE_MEMORY );
Bitmap_dtor( &bmp_block, LEAVE_MEMORY );
Bitmap_dtor( &bmp_ship, LEAVE_MEMORY );
Bitmap_dtor( &bmp_shot, LEAVE_MEMORY );


 Bitmap_dtor( &bmp_buf, LEAVE_MEMORY );

Graphics_dtor( &gfx_buf, LEAVE_MEMORY );


return 0L;
}
